---
title: CSS Grid Layout and Progressive Enhancement
slug: Web/CSS/CSS_Grid_Layout/CSS_Grid_and_Progressive_Enhancement
tags:
  - CSS
  - CSS Grids
  - Design
  - Guide
---
<p class="summary">In Spring of 2017, we saw for the first time a major specification like Grid being shipped into browsers almost simultaneously, and <span class="seoSummary">we now have CSS Grid Layout support in the public versions of Firefox, Chrome, Opera, Safari and Edge. However, while evergreen browsers mean that many of us are going to see the majority of users having Grid Layout support very quickly, there are also old or non-supporting browsers to contend with. In this guide we will walk through a variety of strategies for support.</span></p>

<h2 id="The_supporting_browsers">The supporting browsers</h2>

<p>Other than in Internet Explorer, CSS Grid Layout is unprefixed in Safari, Chrome, Opera,  Firefox and Edge. Support for all the properties and values detailed in these guides is interoperable across browsers. This means that if you write some Grid Layout code in Firefox, it should work in the same way in Chrome. This is no longer an experimental specification, and you are safe to use it in production.</p>

<h2 id="The_Internet_Explorer_and_Edge_situation">The Internet Explorer and Edge situation</h2>

<p>It should be remembered that the original implementation of CSS Grid Layout happened in Internet Explorer 10. This early specification did not contain all of the properties and values that the up-to-date specification has. There are also substantial differences between what shipped in IE10 and the current specification, even where the properties and values appear the same. This early implementation is also the version of Grid Layout implemented in Edge up to version 15.</p>

<p>The IE/Edge (≤15) version of the specification is prefixed with an <code>-ms</code> prefix and the properties implemented in IE/Edge (≤15) are as follows:</p>

<ul>
 <li>{{cssxref("grid-template-columns")}} as <code>-ms-grid-columns</code></li>
 <li>{{cssxref("grid-template-rows")}} as <code>-ms-grid-rows</code></li>
 <li>{{cssxref("grid-row-start")}} as <code>-ms-grid-row</code></li>
 <li>{{cssxref("grid-column-start")}} as <code>-ms-grid-column</code></li>
 <li>{{cssxref("align-self")}} as <code>-ms-grid-row-align</code></li>
 <li>{{cssxref("justify-self")}} as <code>-ms-grid-column-align</code></li>
</ul>

<p>The IE version has additional properties not required in the new specification of <code>-ms-grid-column-span</code> and <code>-ms-grid-row-span</code>. This version does not include auto-placement capability, or grid template areas. Some simple grid layouts could be implemented for IE10, through to Edge 15, using the <code>-ms</code> properties. As these properties are vendor prefixed, they will not effect any browser supporting the up to date and unprefixed specification.</p>

<h3 id="Autoprefixer_grid_layout_support">Autoprefixer grid layout support</h3>

<p>The popular tool <em><a href="https://github.com/postcss/autoprefixer">Autoprefixer</a></em> has been updated to support the <code>-ms-</code> grid version. By default, grid prefixes are disabled, but you can enable it with <code>grid: true</code> option.</p>

<pre class="notranslate">autoprefixer({ grid: 'autoplace' })</pre>

<p>Grid prefixes are disabled by default because some properties can’t be prefixed.</p>

<h2 id="Is_it_safe_to_use_CSS_grids_for_my_layout">Is it safe to use CSS grids for my layout?</h2>

<p>As with any front-end technology choice, the decision to use CSS Grid Layout will come down to the browsers your site visitors are typically using. If they tend to use up-to-date versions of Firefox, Chrome, Opera, and Safari, then it would make sense to start using CSS grids once those browsers update. If your site serves a market sector that is tied to older browsers, however, it may not make sense yet. However, my suggestion is not to make assumptions based on how new specifications have been rolled out in browsers in the past. CSS Grid Layout is very different, in terms of the amount of time it has been in development, and the work of the various browser vendors to ensure that what ships works in the same way for everyone.</p>

<h2 id="Starting_to_use_Grid_in_production">Starting to use Grid in production</h2>

<p>It is worth noting that you do not have to use grid in an <em>all or nothing</em> way. You could start by enhancing elements in your design with grid, that could otherwise display using an older method. Overwriting of legacy methods with grid layout works surprisingly well, due to the way grid interacts with these other methods.</p>

<h3 id="Floats">Floats</h3>

<p>We have typically used <a href="/en-US/docs/Learn/CSS/CSS_layout/Floats">floats</a> to create multiple column layouts. If you have floated an item, which is also a grid item in a supporting browser, the float will no longer apply to the item. The fact is that <em>a grid item takes precedence.</em> In the example below, I have a simple media object. In a non-supporting browser, I use {{cssxref("float")}}, however I have also defined the container as a grid container, in order to use the alignment properties that are implemented in CSS Grids.</p>

<p>The {{cssxref("float")}} no longer applies, and I can use the CSS Box Alignment property {{cssxref("align-self")}} to align my content to the end of the container:</p>

<div id="enhancement_1">
<pre class="brush: css notranslate">* {box-sizing: border-box;}
img {
    max-width: 100%;
    display: block;
}
.media {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
    max-width: 400px;
    display: grid;
    grid-template-columns: 1fr 2fr;
    grid-template-areas: "img content";
    margin-bottom: 1em;
}
.media::after {
    content: "";
    display: block;
    clear: both;
}
.media .image {
    float: left;
    width: 150px;
    margin-right: 20px;
}
.media .text {
    padding: 10px;
    align-self: end;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="media"&gt;
    &lt;div class="image"&gt;&lt;img src="http://placehold.it/150x150" alt="placeholder"&gt;&lt;/div&gt;
    &lt;div class="text"&gt;This is a media object example. I am using floats for older browsers and grid for new ones.&lt;/div&gt;
&lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('enhancement_1', '500', '180') }}</p>
</div>

<p>The image below shows the media object in a non-supporting browser on the left, and a supporting one on the right:</p>

<p><img alt="A simple example of overriding a floated layout using grid." src="https://mdn.mozillademos.org/files/14743/10-float-simple-override.png" style="height: 308px; width: 1620px;"></p>

<h3 id="Using_feature_queries">Using feature queries</h3>

<p>The above example is very simple, and we can get away without needing to write code that would be a problem to browsers that do not support grid, and legacy code is not an issue to our grid supporting browsers. However, things are not always so simple.</p>

<p>In this next example, I have a set of floated cards. I have given the cards a {{cssxref("width")}}, in order to {{cssxref("float")}} them. To create gaps between the cards, I use a {{cssxref("margin")}} on the items, and then a negative margin on the container:</p>

<div id="enhancement_2">
<div class="hidden">
<pre class="brush: css notranslate">* {box-sizing: border-box;}

.wrapper {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
    max-width: 600px;
    margin: 0 auto;
}
.wrapper li {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    color: #d9480f;
}
</pre>
</div>

<pre class="brush: css notranslate">.wrapper ul {
    overflow: hidden;
    margin: 0 -10px;
    padding: 0;
    list-style: none;
}
.wrapper li {
    float: left;
    width: calc(33.333333% - 20px);
    margin: 0 10px 20px 10px;
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
    &lt;ul&gt;
        &lt;li class="card"&gt;&lt;h2&gt;One&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Two&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Three&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Four&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Five&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Six&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
    &lt;/ul&gt;
&lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('enhancement_2', '550', '400') }}</p>
</div>

<p>The example demonstrates the typical problem that we have with floated layouts: if additional content is added to any one card, the layout breaks.</p>

<p><img alt="A floated cards layout demonstrating the problem caused by uneven content height." src="https://mdn.mozillademos.org/files/14745/10-floated-cards.png" style="height: 536px; width: 550px;"></p>

<p>As a concession for older browsers, I have set a {{cssxref("min-height")}} on the items, and hope that my content editors won’t add too much content and make a mess of the layout!</p>

<p>I then enhance the layout using grid. I can turn my {{HTMLElement("ul")}} into a grid container with three column tracks. However, the width I have assigned to the list items themselves still applies, and it now makes those items a third of the width of the track:</p>

<p><img alt="After applying grid to our container, the width of the items is now incorrect as they display at one third of the item width." src="https://mdn.mozillademos.org/files/14747/10-float-width-problem.png" style="height: 721px; width: 550px;"></p>

<p>If I reset the width to <code>auto</code>, then this will stop the float behavior happening for older browsers. I need to be able to define the width for older browsers, and remove the width for grid supporting browsers. Thanks to <a href="/en-US/docs/Web/CSS/@supports">CSS Feature Queries</a> I can do this, right in my CSS.</p>

<p><em>Feature queries</em> will look very familiar if you have ever used a <a href="/en-US/docs/Web/CSS/Media_Queries">media query</a> to create a responsive layout. Rather than checking a {{glossary("viewport")}} width, or some feature of the browser or device, we check for support of a CSS property and value pair using an {{cssxref("@supports")}} rule. Inside the feature query, we can then write any CSS we need to apply our modern layout, and remove anything required for the older layout.</p>

<pre class="brush: css notranslate">@supports (display: grid) {
    .wrapper {
        /* do anything for grid supporting browsers here. */
    }
}
</pre>

<p>Feature queries have excellent browser support, and all of the browsers that support the updated grid specification support feature queries too. You can use them to deal with the issue we have with our enhanced: floated layout.</p>

<p>I use an <code>@supports</code> rule to check for support of <code>display: grid</code>. I then do my grid code on the {{HTMLElement("ul")}}, set my width and {{cssxref("min-height")}} on the {{HTMLElement("li")}} to <code>auto</code>. I also remove the margins and negative margins, and replace the spacing with the {{cssxref("grid-gap")}} property. This means I don’t get a final margin on the last row of boxes. The layout now works, even if there is more content in one of the cards, than the others:</p>

<div id="enhancement_3">
<div class="hidden">
<pre class="brush: css notranslate">* {box-sizing: border-box;}

.wrapper {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
    max-width: 600px;
    margin: 0 auto;
}
.wrapper li {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    color: #d9480f;
}
</pre>
</div>

<pre class="brush: css notranslate">.wrapper ul {
    overflow: hidden;
    margin: 0 -10px;
    padding: 0;
    list-style: none;
}
.wrapper li {
    float: left;
    width: calc(33.333333% - 20px);
    margin: 0 10px 20px 10px;
}
@supports (display: grid) {
    .wrapper ul {
        display: grid;
        grid-template-columns: repeat(3, 1fr);
        gap: 20px;
        margin: 0;
    }
    .wrapper li {
        width: auto;
        min-height: auto;
        margin: 0;
    }
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
    &lt;ul&gt;
        &lt;li class="card"&gt;&lt;h2&gt;One&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Two&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Three&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Four&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Five&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;&lt;h2&gt;Six&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
    &lt;/ul&gt;
&lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('enhancement_3', '550', '480') }}</p>
</div>

<h2 id="Overwriting_other_values_of_display">Overwriting other values of <code>display</code></h2>

<p>Due to the problems of creating grids of items using floats, many of us would use a different method to the floated method shown above to layout a set of cards. Using <code>display: inline-block</code> is an alternate method.</p>

<p>Once again I can use feature queries to overwrite a layout that uses <code>display: inline-block</code>, and again I don’t need to overwrite everything. An item that is set to <code>inline-block</code> becomes a grid item, and so the behaviour of <code>inline-block</code> no longer applies. I have used the {{cssxref("vertical-align")}} property on my item when in the <code>inline-block</code> display mode, but this property does not apply to grid items and, therefore, is ignored once the item becomes a grid item:</p>

<div id="enhancement_4">
<div class="hidden">
<pre class="brush: css notranslate">* {box-sizing: border-box;}

.wrapper {
    border: 2px solid #f76707;
    border-radius: 5px;
    background-color: #fff4e6;
    max-width: 600px;
    margin: 0 auto;
}

.wrapper li {
    border: 2px solid #ffa94d;
    border-radius: 5px;
    background-color: #ffd8a8;
    padding: 1em;
    color: #d9480f;
}
</pre>
</div>

<pre class="brush: css notranslate">.wrapper ul {
    margin: 0 -10px;
    padding: 0;
    list-style: none;
}

.wrapper li {
    display: inline-block;
    vertical-align: top;
    width: calc(33.333333% - 20px);
    margin: 0 10px 20px 10px;
}
@supports (display: grid) {
    .wrapper ul {
        display: grid;
        grid-template-columns: repeat(3, 1fr);
        gap: 20px;
        margin: 0;
    }
    .wrapper li {
        width: auto;
        margin: 0;
    }
}
</pre>

<pre class="brush: html notranslate">&lt;div class="wrapper"&gt;
    &lt;ul&gt;
        &lt;li class="card"&gt;
            &lt;h2&gt;One&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;
            &lt;h2&gt;Two&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;
            &lt;h2&gt;Three&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;
            &lt;h2&gt;Four&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;
            &lt;h2&gt;Five&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
        &lt;li class="card"&gt;
            &lt;h2&gt;Six&lt;/h2&gt;
            &lt;p&gt;We can use CSS Grid to overwrite older methods.&lt;/p&gt;
        &lt;/li&gt;
    &lt;/ul&gt;
&lt;/div&gt;
</pre>

<p>{{ EmbedLiveSample('enhancement_4', '500', '480') }}</p>
</div>

<p>Once again it is the width on the item we need to address, and then any other properties we want to enhance. In this example I have again used <code>gap</code>, rather than margins and negative margins to create my gutters.</p>

<h2 id="How_does_the_specification_define_these_overrides">How does the specification define these overrides?</h2>

<p>The CSS Grid Layout specification details why we can overwrite the behavior of certain properties when something becomes a grid item. The key sections of the specification are:</p>

<ul>
 <li><a href="https://drafts.csswg.org/css-grid/#grid-containers">Establishing Grid Containers</a></li>
 <li><a href="https://drafts.csswg.org/css-grid/#grid-items">Grid Items</a></li>
 <li><a href="https://drafts.csswg.org/css-grid/#grid-item-display">Grid Item Display</a></li>
</ul>

<p>As this behavior is detailed in the specification, you are safe to rely on using these overrides in your support for older browsers. Nothing that I am describing here should be seen as a "hack", we are taking advantage of the fact that the grid specification details the interaction between different layout methods.</p>

<h3 id="Other_values_of_display">Other values of display</h3>

<p>When an element has a parent set to <code>display: grid</code> it is <em>blockified</em>, as defined in the <a href="https://drafts.csswg.org/css-display-3/#blockify">CSS display specification</a>. In the case of our item set to <code>inline-block</code>, this is why <code>display: inline-block</code> no longer applied.</p>

<p>If you are using <code>display: table</code> for your legacy layout, an item set to <code>display: table-cell</code> generates anonymous boxes. Therefore, if you use <code>display: table-cell</code> without any parent element set to <code>display-table</code>, an anonymous table wrapper is created around any adjacent cells, just as if you had wrapped them in a div or other element set to <code>display: table</code>. If you have an item set to <code>display: table-cell</code>, and then in a feature query change the parent to <code>display: grid</code>, this anonymous box creation will not happen. This means you can overwrite <code>display: table</code> based layouts, without having additional anonymous boxes.</p>

<h3 id="Floated_elements">Floated elements</h3>

<p>As we have already seen, {{cssxref("float")}} and also {{cssxref("clear")}} have no effect on a grid item. Therefore you do not need to explicitly set items to <code>float: none</code>.</p>

<h3 id="Vertical_alignment">Vertical alignment</h3>

<p>The alignment property {{cssxref("vertical-align")}} has no effect on a grid item. In layouts using <code>display: inline-block</code> or <code>display: </code><code>table</code>, you might use the vertical-align property to perform basic alignment. In your grid layout you then have the far more powerful box alignment properties.</p>

<h3 id="Multiple-column_layout">Multiple-column layout</h3>

<p>You can also use multiple column layout as your legacy browser plan, as the <code>column-*</code> properties do not apply when applied to a grid container.</p>

<h2 id="Further_reading">Further reading</h2>

<ul>
 <li>For an excellent explanation of feature queries, and how to use them well, see <a href="https://hacks.mozilla.org/2016/08/using-feature-queries-in-css/">Using Feature Queries in CSS</a>.</li>
 <li>A write-up of the differences between the IE/Edge (≤15) Grid implementation and the modern implementation, also covering <em>autoprefixer</em> support, take a look at: <em><a href="https://rachelandrew.co.uk/archives/2016/11/26/should-i-try-to-use-the-ie-implementation-of-css-grid-layout/">Should I try to use the IE implementation of CSS Grid Layout?</a></em></li>
 <li><a href="https://github.com/postcss/autoprefixer#grid-autoplacement-support-in-ie">Autoprefixer and Grid Autoplacement support in IE</a></li>
 <li><a href="https://css-tricks.com/css-grid-in-ie-css-grid-and-the-new-autoprefixer">CSS Grid and the New Autoprefixer</a></li>
</ul>

<section class="Quick_links" id="Quick_Links">
<ol>
 <li><a href="/en-US/docs/Web/CSS"><strong>CSS</strong></a></li>
 <li><a href="/en-US/docs/Web/CSS/Reference"><strong>CSS Reference</strong></a></li>
 <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout">CSS Grid Layout</a></li>
 <li data-default-state="open"><a href="#"><strong>Guides</strong></a>
  <ol>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Basic_Concepts_of_Grid_Layout">Basics concepts of grid layout</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Relationship_of_Grid_Layout">Relationship to other layout methods</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Line-based_Placement_with_CSS_Grid">Line-based placement</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Grid_Template_Areas">Grid template areas</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Layout_using_Named_Grid_Lines">Layout using named grid lines</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Auto-placement_in_CSS_Grid_Layout">Auto-placement in grid layout</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Box_Alignment_in_CSS_Grid_Layout">Box alignment in grid layout</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid,_Logical_Values_and_Writing_Modes">Grids, logical values and writing modes</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_Layout_and_Accessibility">CSS Grid Layout and Accessibility</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/CSS_Grid_and_Progressive_Enhancement">CSS Grid Layout and Progressive Enhancement</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Realizing_common_layouts_using_CSS_Grid_Layout">Realizing common layouts using grids</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Subgrid">Subgrid</a></li>
   <li><a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Masonry_Layout">Masonry layout</a></li>
  </ol>
 </li>
 <li data-default-state="open"><a href="#"><strong>Properties</strong></a>
  <ol>
   <li><code><a href="/en-US/docs/Web/CSS/align-tracks">align-tracks</a></code>{{Experimental_Inline}}</li>
   <li><code><a href="/en-US/docs/Web/CSS/column-gap">column-gap</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/gap">gap</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid">grid</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-area">grid-area</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-auto-columns">grid-auto-columns</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-auto-flow">grid-auto-flow</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-auto-rows">grid-auto-rows</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-column">grid-column</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-column-end">grid-column-end</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-column-start">grid-column-start</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-row">grid-row</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-row-end">grid-row-end</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-row-start">grid-row-start</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-template">grid-template</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-template-areas">grid-template-areas</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-template-columns">grid-template-columns</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/grid-template-rows">grid-template-rows</a></code></li>
   <li><code><a href="/en-US/docs/Web/CSS/justify-tracks">justify-tracks</a></code>{{Experimental_Inline}}</li>
   <li><code><a href="/en-US/docs/Web/CSS/masonry-auto-flow">masonry-auto-flow</a></code>{{Experimental_Inline}}</li>
   <li><code><a href="/en-US/docs/Web/CSS/row-gap">row-gap</a></code></li>
   <li></li>
  </ol>
 </li>
 <li data-default-state="open"><a href="#"><strong>Glossary</strong></a>
  <ol>
   <li><a href="/en-US/docs/Glossary/Grid">Grid</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_lines">Grid lines</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_tracks">Grid tracks</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_cell">Grid cell</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_areas">Grid areas</a></li>
   <li><a href="/en-US/docs/Glossary/Gutters">Gutters</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_Axis">Grid Axis</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_rows">Grid row</a></li>
   <li><a href="/en-US/docs/Glossary/Grid_column">Grid column</a></li>
  </ol>
 </li>
</ol>
</section>
